import java.io.*;
import java.util.*;

public class Graph 
{
	public static HashMap<String, Edge> _Edge_Name_Map = new HashMap<String, Edge>();
	
	public static void Generate_Edges()
	{
		Iterator<KGMLReaction> kgml_reaction_iterator = KGMLData._KGML_Reactions.values().iterator();
		while (kgml_reaction_iterator.hasNext())
		{
			KGMLReaction current_kgml_reaction = kgml_reaction_iterator.next();
			
			Iterator<String> substrate_iterator = current_kgml_reaction._substrates.iterator();
			while (substrate_iterator.hasNext())
			{
				String current_substrate = substrate_iterator.next();
				
				Iterator<String> product_iterator = current_kgml_reaction._products.iterator();
				while (product_iterator.hasNext())
				{
					String current_product = product_iterator.next();
					
					String edge_name;
					if (current_substrate.compareTo(current_product) < 0)
						edge_name = current_substrate + "," + current_product;
					else
						edge_name = current_product + "," + current_substrate;
					
					if (Graph._Edge_Name_Map.containsKey(edge_name) == false)
					{
						Edge new_edge = new Edge(current_substrate, current_product);
						Graph._Edge_Name_Map.put(edge_name, new_edge);
					}
					
					Edge current_edge = Graph._Edge_Name_Map.get(edge_name);
					current_edge.Add_Reaction(current_kgml_reaction);
				}
			}
		}
	}
	
	public static void Output()
	{
		try
		{
			BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(Parameters._Output_Graph_File_Name)));
			
			Iterator<Edge> edge_iterator = Graph._Edge_Name_Map.values().iterator();
			while (edge_iterator.hasNext())
			{
				writer.write(edge_iterator.next().Output_Line());
			}
		
			writer.close();
		}
		catch (Throwable t)
		{
			System.err.println("ERROR: Writing graph output");
			System.exit(0);
		}
	}
}
