import java.util.*;

public class KGMLReaction
{
	public HashSet<String> _substrates = new HashSet<String>();
	public HashSet<String> _products = new HashSet<String>();
	
	public HashMap<String, HashSet<String>> _enzyme_reaction_set_map = new HashMap<String, HashSet<String>>();

	public void Add_Enzyme_Reaction_Mappings(String[] enzymes, String[] reactions)
	{
		if (Parameters._Graph_Level != Parameters._GL_COMPOUND &&
				Parameters._Graph_Level != Parameters._GL_ENZYME &&
				enzymes.length > 1 &&
				reactions.length > 1)
		{
			System.err.println("ERROR: KGML data will not allow desired graph level");
			System.exit(1);
		}
		
		for (int i = 0; i < enzymes.length; i++)
		{
			if (this._enzyme_reaction_set_map.containsKey(enzymes[i]) == false)
				this._enzyme_reaction_set_map.put(enzymes[i], new HashSet<String>());
			
			HashSet<String> current_reaction_set = this._enzyme_reaction_set_map.get(enzymes[i]);
			
			for (int j = 0; j < reactions.length; j++)
			{
				current_reaction_set.add(reactions[j]);
			}
		}
	}
}
