import java.util.*;

public class NetworkCollection
{
	public NetworkMap _network_map;
	public ConservationProfile _profile;
	
	public NetworkCollection()
	{
		this._network_map = new NetworkMap(NIBBSSearch.params._network_map_filename);
		this._profile = new ConservationProfile(NIBBSSearch.params._instance_list_filename);
		
		Iterator<NetworkInstance> _positive_instance_iterator = this._profile._positive_instances.iterator();
		while (_positive_instance_iterator.hasNext())
		{
			NetworkInstance current_instance = _positive_instance_iterator.next();
			String expected_instance_filename = NIBBSSearch.params._instance_directory_name +
												current_instance._instance_name +
												NIBBSSearch.params._instance_file_extension;
			
			
			current_instance.Read_Tags_From_File(expected_instance_filename, this._network_map);
		}

		Iterator<NetworkInstance> _negative_instance_iterator = this._profile._negative_instances.iterator();
		while (_negative_instance_iterator.hasNext())
		{
			NetworkInstance current_instance = _negative_instance_iterator.next();
			String expected_instance_filename = NIBBSSearch.params._instance_directory_name +
												current_instance._instance_name +
												NIBBSSearch.params._instance_file_extension;
			
			
			current_instance.Read_Tags_From_File(expected_instance_filename, this._network_map);
		}
	}	
	
	public String printReport()
	{
		String print_string = "";
		
		print_string += "Map Vertices: " + this._network_map._vertices.size() + "\n";
		print_string += "Map Edges: " + this._network_map._edges.size() + "\n";
		print_string += "\n";
		print_string += "Positive Instances: " + this._profile._positive_instances.size() + "\n";
		print_string += "Negative Instances: " + this._profile._negative_instances.size() + "\n";
		print_string += "\n";
		
		Iterator<Edge> edge_iterator = this._network_map._edges.iterator();
		while (edge_iterator.hasNext())
		{
			Edge current_edge = edge_iterator.next();
			print_string += current_edge._instances.size() + ":" + current_edge.toString();
		}
		
		return print_string;
	}
}
