import java.io.*;
import java.util.*;

public class NetworkInstance
{
	public String _instance_name;
	public HashSet<String> _tag_names;
	
	public NetworkInstance(String instance_name)
	{
		this._instance_name = instance_name;
		this._tag_names = new HashSet<String>();
	}
	
	public void Read_Tags_From_File(String filename, NetworkMap network_map)
	{		
		try
		{
			FileInputStream ni_fis = new FileInputStream(filename);
			InputStreamReader ni_isr = new InputStreamReader(ni_fis);
			BufferedReader ni_reader = new BufferedReader(ni_isr);

			String read_line;
			
			while ((read_line = ni_reader.readLine()) != null)
			{
				String [] line_tokens = read_line.split("\t");
				
				String tag_name = line_tokens[1];
				this._tag_names.add(tag_name);
			}
			
			ni_reader.close();
			ni_isr.close();
			ni_fis.close();
		}
		catch (Throwable t)
		{
			System.out.println("Exiting");
			System.exit(100);
		}

		Iterator<String> tag_name_iterator = this._tag_names.iterator();
		while (tag_name_iterator.hasNext())
		{
			String current_tag_name = tag_name_iterator.next();
			
			if (network_map._tags.containsKey(current_tag_name))
				network_map._tags.get(current_tag_name).Add_Instance(this);
		}
	}
}
