import java.io.*;
import java.util.*;

public class NetworkMap
{
	public static final int EXPECTED_NUMBER_OF_EDGE_TOKENS = 3;
	public static final int EXPECTED_NUMBER_OF_ENDPOINTS = 2;
	
	public LinkedList<Edge> 	_edges;
	
	public Hashtable<String, Vertex> _vertices;
	public Hashtable<String, Tag> 	_tags;
	
	public NetworkMap(String filename)
	{
		this._edges = new LinkedList<Edge>();
		
		this._vertices = new Hashtable<String, Vertex>();
		this._tags = new Hashtable<String, Tag>();
		
		try
		{
			FileInputStream nm_fis = new FileInputStream(filename);
			InputStreamReader nm_isr = new InputStreamReader(nm_fis);
			BufferedReader nm_reader = new BufferedReader(nm_isr);

			String nm_line;
			
			while ((nm_line = nm_reader.readLine()) != null)
			{
				Edge new_edge = new Edge(nm_line, this);
				this._edges.add(new_edge);
			}
			
			nm_reader.close();
			nm_isr.close();
			nm_fis.close();
		}
		catch(Throwable t)
		{
			System.out.println("Exiting");
			System.exit(100);
		}
		
		Iterator<Edge> edge_iterator = this._edges.iterator();
		while (edge_iterator.hasNext())
			edge_iterator.next().Find_Adjacent_Edges();
	}
}
