
public class AlgorithmParameters
{
	public String _nibbs_search_results_file_name = null;
	public String _output_file_name = null;
	
	public double _maximum_bias_score = 0.001;
	
	public AlgorithmParameters(String[] args)
	{
		if (args.length == 0)
		{
			this.Print_Usage();
			System.exit(0);
		}
		
		int parameter_index = 0;
		
		while (parameter_index < args.length)
			parameter_index = Parse_Arguments(args, parameter_index);
		
		this.Check_Required_Arguments();
	}

	public void Print_Usage()
	{
		String output_string = new String();
		
		output_string += "Input Parameters for the NIBBS-SearchSolutionParser algorithm:\n";
		output_string += "  <-r> : REQUIRED : Filename of the NIBBS-Search results\n";
		output_string += "  <-o> : OPTIONAL : Name of the output file\n";
		output_string += "  <-b> : OPTIONAL : Value of the maximum bias score\n";
		
		System.err.print(output_string);
	}
		
	public int Parse_Arguments(String[] args, int index)
	{
		if (args[index].compareTo("-r") == 0)
		{
			index++;
			this._nibbs_search_results_file_name = args[index++];
		}
		else if (args[index].compareTo("-o") == 0)
		{
			index++;
			this._output_file_name = args[index++];
		}
		else if (args[index].compareTo("-b") == 0)
		{
			index++;
			this._maximum_bias_score = Double.parseDouble(args[index++]);
		}
		else
		{
			System.err.println("WARNING: Parameter \"" + args[index++] + "\" ignored");
		}
		
		return index;
	}

	public void Check_Required_Arguments()
	{
		if (this._nibbs_search_results_file_name != null )
			return;

		if (this._nibbs_search_results_file_name == null)
			System.err.println("Missing required argument <-r>");
		
		this.Print_Usage();
		System.exit(1);
	}

}
