import java.io.*;
import java.util.*;


public class NIBBSSearchResults
{
	public LinkedList<Subgraph> _subgraphs = new LinkedList<Subgraph>();
	
	public NIBBSSearchResults()
	{
		int subgraph_count = 0;
		
		try
		{
			BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(NIBBSSearchSubgraphParser.PARAMS._nibbs_search_results_file_name)));
			String read_line;
			
			while ((read_line = reader.readLine()) != null)
			{
				Subgraph new_subgraph = new Subgraph();
				new_subgraph._name = "(" + ++subgraph_count + ")";
				
				new_subgraph._bias_score = Double.parseDouble(read_line.split(": ")[1]);	

				read_line = reader.readLine();
				new_subgraph._number_of_positive_instances = Integer.parseInt(read_line.split(": ")[1].split("-")[0]);
				
				read_line = reader.readLine();
				new_subgraph._number_of_negative_instances = Integer.parseInt(read_line.split(": ")[1].split("-")[0]);
				
				new_subgraph._total_number_of_instances = new_subgraph._number_of_positive_instances + new_subgraph._number_of_negative_instances;
				
				while ((read_line = reader.readLine()) != null && read_line.compareTo("") != 0)
				{
					String[] columns = read_line.split("\t.: *"); 
					new_subgraph._edge_names.add(columns[1]);
				}

				if (new_subgraph._bias_score <= NIBBSSearchSubgraphParser.PARAMS._maximum_bias_score)
				{
					boolean subgraph_redundant = false;
					
					Iterator<Subgraph> subgraph_iterator = this._subgraphs.iterator();
					while (subgraph_iterator.hasNext())
					{
						if (new_subgraph.Equals(subgraph_iterator.next()))
						{
							subgraph_redundant = true;
							break;
						}
					}
					
					if (!subgraph_redundant)
						this._subgraphs.add(new_subgraph);
				}
				
				if (read_line == null)
					break;
			}
					
			reader.close();
		}
		catch (Throwable t)
		{
			System.err.println("ERROR: NIBBSSearchResults Constructor");
			System.exit(1);
		}		
	}
		
	public void Write_Output()
	{
		String output_string = new String();
		
		Iterator<Subgraph> subgraph_iterator = this._subgraphs.iterator();
		while (subgraph_iterator.hasNext())
		{
			output_string += subgraph_iterator.next().toString();
			
			if (subgraph_iterator.hasNext())
				output_string += "\n";
		}

		if (NIBBSSearchSubgraphParser.PARAMS._output_file_name == null)
			System.out.println(output_string);
		else
		{
			try
			{
				BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(NIBBSSearchSubgraphParser.PARAMS._output_file_name)));
				writer.write(output_string);
				writer.close();
			}
			catch(Throwable t)
			{
				System.err.println("Error: Write_Output method");
			}
		}
	}
}
