import java.util.*;

public class Subgraph 
{
	public String _name;
	public HashSet<String> _edge_names = new HashSet<String>();
	
	public int _total_number_of_instances = 0;
	public int _number_of_positive_instances = 0;
	public int _number_of_negative_instances = 0;
	
	public double _bias_score = 0.0;
	
	public boolean Equals (Subgraph comparison_subgraph)
	{
		if (this._edge_names.size() != comparison_subgraph._edge_names.size())
			return false;
		
		Iterator<String> edge_name_iterator = this._edge_names.iterator();
		while (edge_name_iterator.hasNext())
		{
			if (comparison_subgraph._edge_names.contains(edge_name_iterator.next()) == false)
				return false;
		}
		
		return true;
	}
	
	public String toString()
	{
		String return_string = new String();
		
		return_string += this._name + "\n";
		return_string += this._edge_names.size() + " " +
						 this._total_number_of_instances + ":" +
						 this._number_of_positive_instances + "," +
						 this._number_of_negative_instances + " " +
						 this._bias_score + "\n";
		
		Iterator<String> edge_name_iterator = this._edge_names.iterator();
		while (edge_name_iterator.hasNext())
		{
			return_string += edge_name_iterator.next() + "\n";
		}
		
		return return_string;
	}
}
